DEF VAR cODBC-DSN      AS CHAR NO-UNDO INIT "dmi-test".
DEF VAR ObjRecordSet   AS COM-HANDLE NO-UNDO.
DEF VAR ObjConnection  AS COM-HANDLE NO-UNDO.
DEF VAR ObjCommand     AS COM-HANDLE NO-UNDO.

DEF VAR c-Error        AS CHAR       NO-UNDO.

DEF VAR ODBC-QUERY     AS CHAR       NO-UNDO.
DEF VAR ODBC-RECCOUNT  AS INT        NO-UNDO.
DEF VAR ODBC-NULL      AS CHAR       NO-UNDO.
DEF VAR ODBC-STATUS    AS CHAR       NO-UNDO.
DEF VAR ODBC-CURSOR    AS INT        NO-UNDO.
DEF VAR std-ch         AS CHAR       NO-UNDO.
DEF VAR cStatus        AS CHAR       NO-UNDO.

FORM WITH FRAME dmi WITH NO-BOX.

DEF TEMP-TABLE ttEmp
    FIELD EMPNO    AS INT
    FIELD ENAME    AS CHAR
    FIELD JOB      AS CHAR FORMAT "x(10)"
    FIELD MGR      AS CHAR
    FIELD HIREDATE AS CHAR
    FIELD SAL      AS INT
    FIELD COMM     AS CHAR
    FIELD DEPTNO   AS INT
.

ODBC-QUERY = "SELECT * FROM emp".

{utils/odbc-open.i &query=ODBC-QUERY &locktype=1}

IF ODBC-RECCOUNT > 0  AND NOT ODBC-RECCOUNT = ?  THEN DO:
  ObjRecordSet:MoveFirst.
  DO WHILE ODBC-CURSOR < ODBC-RECCOUNT:
      CREATE ttEmp.
      ASSIGN
          EMPNO     = ObjRecordSet:FIELDS("EMPNO"):VALUE
          ENAME     = ObjRecordSet:FIELDS("ENAME"):VALUE
          JOB       = ObjRecordSet:FIELDS("JOB"):VALUE
          MGR       = ObjRecordSet:FIELDS("MGR"):VALUE
          HIREDATE  = ObjRecordSet:FIELDS("HIREDATE"):VALUE
          SAL       = ObjRecordSet:FIELDS("SAL"):VALUE
          COMM      = ObjRecordSet:FIELDS("COMM"):VALUE
          DEPTNO    = ObjRecordSet:FIELDS("DEPTNO"):VALUE
      .  
      ODBC-CURSOR = ODBC-CURSOR + 1.
      ObjRecordSet:MoveNext.
  END. /* do while ODBC... retrieved a single data row */
END. /* if ODBC reccont retrieved all data rows */

{utils/odbc-close.i}

FOR EACH ttEmp:
    DISP ttEmp WITH WIDTH 130.
END.



PROCEDURE Open-ODBC-Connection:
    DEF OUTPUT PARAMETER pObjConnection AS COM-HANDLE NO-UNDO.
    DEF OUTPUT PARAMETER pObjRecordSet  AS COM-HANDLE NO-UNDO.
    DEF OUTPUT PARAMETER pObjCommand    AS COM-HANDLE NO-UNDO.
    DEF OUTPUT PARAMETER pError         AS CHAR       NO-UNDO.
    DEF VAR ODBC-DSN      AS CHAR       NO-UNDO.
    DEF VAR ODBC-SERVER   AS CHAR       NO-UNDO.
    DEF VAR ODBC-USERID   AS CHAR       NO-UNDO INIT "scott".
    DEF VAR ODBC-PASSWD   AS CHAR       NO-UNDO INIT "oracle".

 /* Create the connection object for the link to SQL */
 CREATE "ADODB.Connection" pObjConnection.
 /* Create a recordset object ready to return the data */
 CREATE "ADODB.RecordSet" pObjRecordSet.
 /* Create a command object for sending the SQL statement */
 CREATE "ADODB.Command" pObjCommand.
/* The ODBC DSN */
 ASSIGN
    ODBC-DSN    = cODBC-DSN
    pError = "".
.
 /* Open up the connection to the ODBC Layer */
 pObjConnection:Open("data source=" + ODBC-DSN /*+ ";server=" + ODBC-SERVER*/, ODBC-USERID, ODBC-PASSWD, 0 ) NO-ERROR.

 IF ERROR-STATUS:NUM-MESSAGES > 0 THEN pError = "1) Error: Could not establish connection.".

END PROCEDURE.
